#### Requirements

* Operating System: Linux, OS X or Windows.

#### Compilation
* Prepare the cURL for transferring data with URLs, reference to the <a href="https://curl.haxx.se/libcurl/c/libcurl-tutorial.html">curl tutorial</a>.
* Compile "ultra_stream_curl.c", and link to "libcurl"
* Build the ultra_stream_curl executable file 

#### Example

* Navigate into the bin directory and run the ultra_stream_curl

```
cd ultra-stream-api/demo/c/bin
cp ultra_stream_hdmi_rev_c_1_2_123.mwf linux
cd linux
./ultra_stream_curl <hostip:port>
```
* Response

```

***** 1. login *****
login response data:
{
        "result": 0
}

***** 2. get info *****
get info response data:
{
        "result": 0,
        "mac-addr": {
                "eth": "70:b3:d5:75:d0:4c",
                "wifi": "70:b3:d5:75:d0:4d",
                "blue": "70:b3:d5:75:d0:4e"
        },
        "snapshot": "/tmp/sbox-snapshot/sbox-quarter.jpg",
        "product": {
                "sn": "C301171116015",
                "product-id": 769,
                "hardware-ver": "C",
                "firmware-id": 1,
                "firmware-ver-s": "1.2.122",
                "factory-firmware-ver-s": "1.2.116",
                "product-name": "Ultra Stream",
                "module-name": "Ultra Stream HDMI",
                "manu-name": "MAGEWELL",
                "features": 1,
                "max-lock-count": 2
        },
        "audio-range": {
                "hdmi": {
                        "max": 6.00,
                        "min": -100.00,
                        "def": 0.00
                },
                "mic": {
                        "max": 55.25,
                        "min": -12.00,
                        "def": 0.00
                },
                "phone": {
                        "max": 6.00,
                        "min": -57.00,
                        "def": 0.00
                }
        },
        "codec-cap": {
                "resolutions": [
                        {
                                "w": 480,
                                "h": 360
                        },
                        {
                                "w": 640,
                                "h": 360
                        },
                        {
                                "w": 640,
                                "h": 480
                        },
                        {
                                "w": 720,
                                "h": 480
                        },
                        {
                                "w": 720,
                                "h": 576
                        },
                        {
                                "w": 768,
                                "h": 576
                        },
                        {
                                "w": 800,
                                "h": 600
                        },
                        {
                                "w": 960,
                                "h": 540
                        },
                        {
                                "w": 1024,
                                "h": 768
                        },
                        {
                                "w": 1280,
                                "h": 720
                        },
                        {
                                "w": 1280,
                                "h": 800
                        },
                        {
                                "w": 1280,
                                "h": 960
                        },
                        {
                                "w": 1280,
                                "h": 1024
                        },
                        {
                                "w": 1440,
                                "h": 900
                        },
                        {
                                "w": 1440,
                                "h": 1080
                        },
                        {
                                "w": 1600,
                                "h": 1200
                        },
                        {
                                "w": 1920,
                                "h": 1080
                        }
                ],
                "durations": [
                        {
                                "name": "15 FPS",
                                "value": 666667
                        },
                        {
                                "name": "24 FPS",
                                "value": 416667
                        },
                        {
                                "name": "25 FPS",
                                "value": 400000
                        },
                        {
                                "name": "29.97 FPS",
                                "value": 333667
                        },
                        {
                                "name": "30 FPS",
                                "value": 333333
                        },
                        {
                                "name": "50 FPS",
                                "value": 200000
                        },
                        {
                                "name": "59.94 FPS",
                                "value": 166833
                        },
                        {
                                "name": "60 FPS",
                                "value": 166667
                        }
                ],
                "profile": [
                        {
                                "name": "Baseline",
                                "value": 0
                        },
                        {
                                "name": "Main profile",
                                "value": 1
                        },
                        {
                                "name": "High profile",
                                "value": 2
                        }
                ],
                "hevc-profile": [
                        {
                                "name": "Main profile",
                                "value": 0
                        }
                ],
                "video-kbps": [
                        {
                                "name": "256 Kbps",
                                "value": 256
                        },
                        {
                                "name": "512 Kbps",
                                "value": 512
                        },
                        {
                                "name": "768 Kbps",
                                "value": 768
                        },
                        {
                                "name": "1 Mbps",
                                "value": 1024
                        },
                        {
                                "name": "1.5 Mbps",
                                "value": 1536
                        },
                        {
                                "name": "2 Mbps",
                                "value": 2048
                        },
                        {
                                "name": "3 Mbps",
                                "value": 3072
                        },
                        {
                                "name": "4 Mbps",
                                "value": 4096
                        },
                        {
                                "name": "8 Mbps",
                                "value": 8192
                        }
                ],
                "audio-kbps": [
                        {
                                "name": " 16 Kbps",
                                "value": 16
                        },
                        {
                                "name": " 32 Kbps",
                                "value": 32
                        },
                        {
                                "name": " 48 Kbps",
                                "value": 48
                        },
                        {
                                "name": " 64 Kbps",
                                "value": 64
                        },
                        {
                                "name": " 96 Kbps",
                                "value": 96
                        },
                        {
                                "name": "128 Kbps",
                                "value": 128
                        }
                ],
                "gop-sec": [
                        {
                                "name": " 1 sec",
                                "value": 1
                        },
                        {
                                "name": " 2 sec",
                                "value": 2
                        },
                        {
                                "name": " 5 sec",
                                "value": 5
                        },
                        {
                                "name": "10 sec",
                                "value": 10
                        },
                        {
                                "name": "30 sec",
                                "value": 30
                        },
                        {
                                "name": "60 sec",
                                "value": 60
                        }
                ],
                "video-range": [
                        {
                                "name": "Full range (0-255)",
                                "value": 1
                        },
                        {
                                "name": "Limited range (16-235)",
                                "value": 0
                        }
                ],
                "stat-sec": [
                        {
                                "name": " 1 sec",
                                "value": 1
                        },
                        {
                                "name": " 5 sec",
                                "value": 5
                        },
                        {
                                "name": "10 sec",
                                "value": 10
                        },
                        {
                                "name": "30 sec",
                                "value": 30
                        },
                        {
                                "name": "60 sec",
                                "value": 60
                        }
                ],
                "video-codec": [
                        {
                                "name": "H.264",
                                "value": 0
                        },
                        {
                                "name": "HEVC",
                                "value": 1
                        }
                ]
        }
}

***** 3. upload firmware *****
upload firmware response data:
{
        "result": 0,
        "up-to-date": true,
        "version": "1.2.123",
        "size": 12494463
}
```


